/* Ein Sheriffstern, der dem Traeger, so er Sheriff ist, folgende
   Funktionen bietet: - Opfer disconnecten
                      - Opfer fuer bestimmte Zeit ins Jail werfen
                      - Opfer fuer unbestimmte Zeit ins Jail werfen
		      - Opfer aus dem Gefaengnis entlassen

   Fuer jede Funktion muss ein Grund genannt werden. (Ausser entlassen.)
   Jede Verwendung wird ausfuehrlich geloggt.
*/

#include <properties.h>
#include <language.h>
#include <moving.h>
#include <combat.h>
#include "sheriffstern.h"

inherit "/std/armour";

create() {
  if (!is_clone(this_object())) return;
  ::create();

  SetProp(P_SHORT, "Ein Sheriffstern");
  SetProp(P_LONG, break_string(
                  "Dieser Sheriffstern verleiht den Mitgliedern des "+
		  "Sheriffteams bestimmte Faehigkeiten zur Ausuebung "+
		  "ihres Amtes. Informationen mit 'sheriffhilfe'."));

  AddId(({"stern", "sheriffstern", "\nsheriffstern"}));

  SetProp(P_NAME, "Sheriffstern");
  SetProp(P_GENDER, MALE);
  SetProp(P_WEIGHT, 100);
  SetProp(P_MATERIAL, MAT_BRASS);
  SetProp(P_NODROP,1);
  SetProp(P_NEVERDROP,1);
  SetProp(P_AUTOLOADOBJ,1);
  SetProp(P_NOSELL, break_string("Du kannst den Sheriffstern "+
				 "nicht verkaufen!\n"));
  SetProp(P_AC, 0);
  SetProp(P_ARMOUR_TYPE, AT_MISC);
  
  SetProp(P_WORN_TEXT, "angeheftet");
  SetProp(P_WEAR_TEXT, ({"Du heftest Dir den Sheriffstern an.\n",
			   " heftet sich einen Sheriffstern an.\n"}));
  SetProp(P_UNWEAR_TEXT, ({"Du nimmst den Sheriffstern ab.\n",
			     " nimmt den Sheriffstern ab.\n"}));

  AddSpecialDetail(({"faehigkeiten", "faehigkeit", "information", "informationen"}), "_anleitung");
  AddCmd(({"faehigkeiten", "faehigkeit", "sheriffhilfe", "anleitung", "information", "informationen"}),
	 "_anleitung");

  AddCmd(({"kick", "kicke"}), "_kicken");
  AddCmd(({"bestraf", "bestrafe"}), "_bestrafen");
  AddCmd(({"verbann", "verbanne"}), "_verbannen");
  AddCmd(({"begnadig", "begnadige"}), "_begnadigen");
}

_kicken(str) {
  MASTER->_kicken(str, this_player());
  return 1;
}

_bestrafen(str) {
  MASTER->_bestrafen(str, this_player());
  return 1;
}

_verbannen(str) {
  MASTER->_verbannen(str, this_player());
  return 1;
}

_begnadigen(str) {
  MASTER->_begnadigen(str, this_player());
  return 1;
}

_anleitung() {
  MASTER->_anleitung(this_player());
  return 1;
}
