// 
//  Tester
//  (c) by Rochus Wessels
//        (Rochus@MorgenGrauen)
//
//  Die Weitergabe und Verwendung ist nur erlaubt,
//  wenn diese Meldung nicht geandert wird
//
/* Revision 1.1  1998/12/05  20:10:00  Sorcerer
 * P_INDOORS auf ENV_INDOORS geaendert
 */
      
inherit "/std/npc";
inherit "/std/player/viewcmd";

#include <environment.h>
#include <properties.h>
#include <language.h>
#include <moving.h>
#include "/secure/wizlevels.h"
//#include "/players/ezo/def.h"


#define TP	this_player()
#define TO	this_object()
#define ME	this_object()
#define ENV(x)	environment(x)

object pl;
mapping det,ex_det,found,miss;
string testdir,tester_id;
string *testfiles;

mapping gesamt;
int k;

string long() {
  if (!TP || !IS_WIZARD(TP)) return ::long();
  return (::long()+"\nAls Magier kannst Du folgende Befehle aufrufen:\n"+
    "exa               - testet den Raum, in dem Du Dich befindest.\n"+
    "testdir directory - nimmt an, dass alle Files, die mit .c enden,\n"+
    "Raeume sind und testet diese. Ausgabe in /log/tester/deinname.log\n");
}

create () {
  if (sizeof(explode(file_name(this_object()),"#"))==1) return;
  ::create();
  det=(["-"]);
  ex_det=(["-"]);
  found=(["-"]);
  miss=(["-"]);

  SetProp(P_NAME, "Tester");
  SetProp(P_SHORT,"Ein Tester");
  SetProp(P_LONG,"Ein Tester.\n");
  AddId(({"tester", "raumtester"}));
  set_living_name("raumtester");
  SetProp(P_RACE,"Monster");              
  SetProp(P_GENDER,MALE);
  SetProp(P_ARTICLE,1);

  SetProp(P_LEVEL,18);
  SetProp(P_ALIGN, 0);
  SetProp(P_MAX_HP, 250000);
  SetProp(P_HP, 250000);
  SetProp(P_XP, 0);
  SetProp(P_HANDS, ({" mit seinen Haenden", 50}));
  SetProp(P_MAX_HANDS, 2);
  SetProp(P_AGGRESSIVE,0);
  SetProp(P_BODY,105000);
  SetProp(P_NOATTACK, 1);

  pl=0;
  testdir=0;
  testfiles=0;
  tester_id=0;
  add_action("_look","schau");
  AddCmd("exa","examine");
  AddCmd("testdir","init_test");
  seteuid(getuid());
  gesamt=([]);
}

msg_out(string str) {
  if (!str) return;
  if (!objectp(pl)) return;
  tell_object(pl,str);
}

examine() {
  if (TP==TO) return 0;
  if (!TP || !IS_WIZARD(TP)) return 0;
  notify_fail("Der Tester sagt: Ich teste noch!\n");
  if (objectp(pl) || stringp(testdir)) return 0;
  pl=TP;
  tester_id=getuid(TP);
  testdir=0;
  det=(["-"]);
  ex_det=(["-"]);
  found=(["-"]);
  miss=(["-"]);
  if (find_call_out("test_detail")<0)
	call_out("test_detail",2);
  if (ENV(TO) && (ENV(TO)->QueryProp(P_INDOORS)!=0))
	det+=(["decke","boden","wand","waende"]);
  command("schau");
  return 1;
}

test_room() {
  string fname,str;
  if (!testdir || !testfiles || !sizeof(testfiles)) {
    if (stringp(tester_id)) {
      str=vergleiche();
      k=0;
      gesamt=([]);
      log_file("tester/"+tester_id,str+"Test abgeschlossen.\n");
      if (find_player(tester_id)) {
        tell_object(find_player(tester_id), "Der Tester teilt Dir mit: "+
          "Ich bin fertig.\n"); }
      return remove(); } }
  fname=testfiles[0];
  testfiles-=({fname});
  fname=testdir+"/"+extract(fname,0,-3);

  det=(["-"]);
  ex_det=(["-"]);
  found=(["-"]);
  miss=(["-"]);
  merkdetails();

  if (move(fname,M_GO)<=0)
	return call_out("test_room",1);

  if (find_call_out("test_detail")<0)
	call_out("test_detail",2);
  if (ENV(TO) && (ENV(TO)->QueryProp(P_INDOORS)!=0))
	det+=(["decke","boden","wand","waende"]);
  command("schau");
}

init_test (string str) 
{
  notify_fail("Keinen Pfad angegeben!\n");
  if (!str) return 0;
  notify_fail("Hae? Ich geb mir doch selber keine Befehle?\n");
  if (TP==TO) return 0;
  notify_fail("Du bist kein Magier!\n");
  if (!TP || !IS_WIZARD(TP)) return 0;
  notify_fail("Der Tester sagt: Ich teste noch!\n");
  // if (objectp(pl) || stringp(testdir)) return 0;
  pl=0;
  testdir=str;
  tester_id=getuid(TP);
  testfiles=get_dir(str+"/*.c");
  notify_fail("Keine Dateien zum Ueberpruefen gefunden!\n");
  if (!testfiles || !sizeof(testfiles)) return 0;
  test_room();
  return 1;
}


catch_tell (msg) {
  string *words;
  string str;
  int i,n,anf;

  if (!msg) return;
  words=regexplode(msg,"[^A-Za-z0-9]");n=sizeof(words);
  if (!n) return;

  anf=1;
  for (i=0;i<n;i++) {
	str=words[i];
	if (str=="" || str==" ") continue;
	if (str=="." || str==":" || str=="?" || str=="!") {anf=1;continue;}
	if (sizeof(regexp(({str}),"[^A-Za-z0-9]"))) continue;
	if (sizeof(regexp(({str}),"\\<[0-9]*\\>"))) continue; // keine Zahlen
	if (str!=capitalize(str)) continue;
	if (anf) {anf=0;continue;}  // kein Satzanfang
	if (member_array(str,({"Du","Dir","Dich","Dein","Deiner","Deine","Deinem","Deinen","Nord","Sued","West","Ost","Nordwest","Nordost","Suedwest","Suedost","Norden","Sueden","Westen","Osten","Nordwesten","Suedwesten","Nordosten","Suedosten","Richtung","Richtungen","Besonderes"}))>=0) continue;
	det+=([lower_case(str)]);
  }
}

smart_log() {}

complete () {
  mixed *ind;
  string str;
  string *strs;
  int i;

  found-=(["-"]);
  miss-=(["-"]);
  str="Missing Details in "+file_name(ENV(ME))+":\n";
  strs=({});ind=m_indices(miss);
  for (i=sizeof(ind)-1;i>=0;i--)
	if (stringp(ind[i])) strs+=({((string)ind[i])});
  strs=sort_array(strs,lambda(({'a,'b}),({#'<, 'a, 'b})));
  for (i=sizeof(strs)-1;i>=0;i--)
	str+=(capitalize(strs[i])+((string)(i?", ":"")));
  str+=".\n";
  msg_out(str);
  pl=0;

  if (stringp(testdir)) {
	log_file("tester/alle",str);
	if (stringp(tester_id) && sizeof(strs))
	  log_file("tester/"+tester_id,str);
	test_room();
  }
}

test_detail() {
  mixed *ind;
  string str,suf,ostr;
  string *strs;
  int i,fnd;

  det-=ex_det;
  ind=m_indices(det);
  if (!sizeof(ind)) return complete();
  if (!stringp(ind[0])) return complete();
  str=((string)ind[0]);

  ex_det+=([str]);det-=([str]);
  if (!present(str,TO) && !present(str,ENV(TO))) {
	strs=({str});ostr=str;
	if ((suf=extract(str,-1,-1))=="s" || suf=="n" || suf=="e") {
	  ostr=extract(str,0,-2);
	  strs+=({ostr});
	  ostr+=("("+suf+")");
	}
	if ((suf=extract(str,-2,-1))=="es" || suf=="en") {
	  ostr=extract(str,0,-3);
	  strs+=({ostr});
	  ostr+=("("+suf+")");
	}
	fnd=0;
	for (i=sizeof(strs)-1;i>=0;i--) {
	  if (command("schau "+strs[i])) {
		fnd=1;
		found+=([strs[i]]);
		msg_out(":"+strs[i]+": gefunden.\n");
	  }
	  ex_det+=([strs[i]]);
	}
	if (!fnd) {
	  miss+=([ostr]);
	  msg_out(":"+ostr+": NICHT gefunden!\n");
	}
  }
  if (sizeof(m_indices(det)))
	call_out("test_detail",1);
  else
	complete();
}

int merkdetails(string str) {
  string *test1;
  mixed *test2,*details;
  mapping neu;
  int i,m;
  test1=m_indices(environment(this_player())->QueryProp(P_DETAILS));
  test2=m_values(environment(this_player())->QueryProp(P_DETAILS));
  for(i=0;i<sizeof(test2);i++)
    if(mappingp(test2[i])) test2[i]=test2[i][m_indices(test2[i])[0]];
  details=m_indices(neu=mkmapping(test2,test1));
    for(i=0;i<sizeof(details);i++) {
      neu[details[i]]="";
      for(m=0;m<sizeof(test2);m++)
        if(details[i]==test2[m]) neu[details[i]]+=test1[m]+" "; }
  gesamt+=([k:neu]);
  k++;
  return 1;
}

string vergleiche(string str) {
  string *test1;
  mixed *test2,*dummy,*mehrfach;
  int total,i,m;
  mapping neu;
  if(!k) return "";
  if(k==1) return "";
  mehrfach=({});
  total=0;
  test1=({});
  test2=({});
  for(i=0;i<k;i++) {
    dummy=m_indices(gesamt[i]);
    total+=sizeof(dummy);
    for(m=0;m<sizeof(dummy);m++)
      if(member(test2,dummy[m])!=-1&&member(mehrfach,dummy[m])==-1)
        mehrfach+=({dummy[m]}); 
    neu=mkmapping(m_indices(gesamt[i])+test2,m_values(gesamt[i])+test1);
    test1=m_values(neu);
    test2=m_indices(neu); }
  neu=mkmapping(test2,test1);
  return break_string("Insgesamt waren in "+k+" Raeumen "+
    total+" Details. Davon waren insgesamt "+
    sizeof(neu)+" verschiedene Details vorhanden, von denen "+
    sizeof(mehrfach)+" mehrfach und "+
    (sizeof(neu)-sizeof(mehrfach))+" einfach vorkamen.");
}
