/* ein generisches Geistwesen, nicht unbedingt nur fuer einen Geist
 * Samtpfote@tamedhon.at
 */

#include <class.h> 
#include <properties.h>
#include <combat.h>
#include <moving.h>

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)


inherit "/std/mnpc";
inherit "/std/player/moneyhandler";

void add_combat_spells()
{
    int level;
    
    level = QueryProp(P_LEVEL);

    if(QueryProp(P_ALIGN) < 0)
    {
        AddSpell(3, level*8,
            this_object()->Name()+" heult schauerlich, dass es Dir durchs Mark und Bein geht.\n",
            this_object()->Name()+" heult schauerlich, dass es Dir durchs Mark und Bein geht.\n", 
            ({ DT_AIR, DT_SOUND }),
            ([SP_SHOW_DAMAGE: 1]));            
        AddSpell(2, level*10,
            this_object()->Name()+" floesst Dir Angst und Schrecken ein.\n",
            this_object()->Name()+" floesst @WEN Angst und Schrecken ein.\n",
            ({ DT_TERROR }),
            ([SP_SHOW_DAMAGE: 1]));
        AddSpell(1, level*20,
            this_object()->Name()+" versucht, von Dir Besitz zu ergreifen!\n",
            this_object()->Name()+" versucht, von @WEN Besitz zu ergreifen!\n",
            ({ DT_UNHOLY, DT_RIP, DT_BLUDGEON }),
            ([SP_SHOW_DAMAGE: 1, SP_PHYSICAL_DAMAGE: 1]));
        AddSpell(2, level*12,
            this_object()->Name()+" lacht Dich einfach nur aus.\n",
            this_object()->Name()+" lacht @WEN einfach nur aus.\n",
            ({ DT_UNHOLY, DT_SOUND }),
            ([SP_SHOW_DAMAGE: 1]));
    }
    else
    {
        AddSpell(3, level*8,
            this_object()->Name()+" streichelt Dich sanft ueber Dein Gesicht.\n",
            this_object()->Name()+" streichelt @WEN sanft ueber @WESSEN Gesicht.\n", 
            ({ DT_BLUDGEON }),
            ([SP_SHOW_DAMAGE: 1]));            
        AddSpell(2, level*10,
            this_object()->Name()+" strahlt Dich liebevoll an.\n",
            this_object()->Name()+" strahlt @WEN liebevoll an.\n",
            ({ DT_HOLY, DT_LIGHT }),
            ([SP_SHOW_DAMAGE: 1]));
        AddSpell(1, level*20,
            this_object()->Name()+" schickt konzentrierte Lichtstrahlen auf Dich!\n",
            this_object()->Name()+" schickt konzentrierte Lichtstrahlen auf @WEN!\n",
            ({ DT_HOLY, DT_LIGHT }),
            ([SP_SHOW_DAMAGE: 1]));
    }
    
    AddSpell(1, level*22,
        this_object()->Name()+" durchdringt Dich mit der geisterhaften Gestalt.\n",
        this_object()->Name()+" durchdringt @WEN mit der geisterhaften Gestalt.\n",
        DT_MAGIC,
        ([SP_PHYSICAL_ATTACK: 1]));
}


string *_query_racestring()
{
    if(QueryProp(P_GENDER) == MALE)
    {
	return ({"Geist", "Geistes", "Geist", "Geist"});
    }
    else
    {
	return ({"Geisterfrau", "Geisterfraus", "Geisterfrau", "Geistfrau"});
    }
}

int Defend(int dam, string *dts, mixed spell, object enemy)
{
    int i;
    string *magic;
    
    magic=dts-m_indices(PHYSICAL_DAMAGE_TYPES);
    if(!sizeof(phy))
    {
        tell_object(enemy, 
            sprintf("Deine Waffe fuehlt keinen Widerstand, als sie durch "+
                        "%s durchgleitet.\n", name(WEN)));
        tell_room(environment(),
            sprintf("%s Waffe passiert %s und verletzt %s kaum.\n",
                    enemy->Name(), name(WEN), QueryPronoun()),
            ({ enemy }));
        dam/=10;
    }

    return ::Defend(dam, dts, spell, enemy);
}

int _query_poison() { return 0; }
int _query_blind() { return 0; }

void create_default_geist(int level)
{
    int	num;

    ::create_default_npc(level);
    SetProp(P_SPELLRATE, 30+level/2+random(level*2)); 
    if(QueryProp(P_SPELLRATE) >= 100)
    { SetProp(P_SPELLRATE, 80+random(16)); }

    SetProp(P_KILL_NAME, this_object()->name());
    if(level <= 50+random(6))
    { 
	SetProp(P_ATTRIBUTES, 
	    ([A_CON: level+(random(level)/6)-(random(level)/6),
	      A_DEX: level+(random(level)/6)-(random(level)/6),
	      A_INT: level+(random(level)/6)-(random(level)/6),
	      A_STR: level+(random(level)/6)-(random(level)/6)
	    ]));
    }
    else
    {
	SetProp(P_ATTRIBUTES, ([A_CON: 35, A_DEX: 35, A_INT: 35, A_STR: 35]));
    }
    
    SetProp(P_BODY, (level<30?level*4:level*3)+random(15));
    AddId("\ngeist");
    AddId("geist");
    
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "Geist");
    SetProp(P_RACE, "Geist");
    SetProp(P_SHORT, "Ein unbeschriebener Geist");
    SetProp(P_LONG, "Das ist ein unbeschriebener Geist.\n");
    SetProp(P_AVERAGE_SIZE, 170);
    SetProp(P_SIZE, 150+random(40));
    SetProp(P_AVERAGE_WEIGHT, 30000);
    SetProp(P_WEIGHT, 25000+random(10000));
    SetProp(P_ATTRIBUTES_OFFSETS, 
	([A_DEX: 3, A_CON: -2, A_INT: 3, A_STR: -3]));
    SetProp(P_MAX_HANDS, 2);
    SetProp(P_AGGRESSIVE, 0);
    SetProp(P_DEFAULT_INFO,
        ({"schwebt um Dich herum.\n",
          "verblasst etwas.\n",
          "loest sich beinahe auf diese Frage auf.\n",
          "heult nur schauerlich.\n",
          "schwebt unschluessig vor und zurueck.\n",
	  "hat davon keinen Schimmer.\n",
	  "interessiert sich nicht dafuer.\n",
	  "gruebelt darueber nach, aber hat trotzdem keine Ahnung.\n"
	}));
    SetProp(P_LOG_INFO, 1);
    SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN: 0, T_RANGE_MAX: 50]));  
    SetProp(P_NOMAGIC, 10+QueryProp(P_LEVEL)/3);
    SetProp(P_WIMPY, 0);
    SetProp(P_NOCORPSE, 1);
    SetProp(P_DIE_MSG, " loest sich mit einen spitzen Schrei in Nichts auf.\n");

    SetProp(P_MSGIN, "schwebt herein");
    SetProp(P_MSGOUT, "schwebt#");
    SetProp(P_MMSGIN, "verfestigt sich");
    SetProp(P_MMSGOUT, "loest sich vor Deinen Augen auf");
    
    SetProp(P_MAX_FOOD, 100);
    SetProp(P_MAX_ALCOHOL, 100);
    SetProp(P_MAX_DRINK, 100);
    
    SetProp(P_ALIGN, -500+random(1000));
    
    SetProp(P_HANDS, 
	({" mit geisterhaften Beruehrungen",
	  60+(level/3)+random(10),
	  ({ DT_TERROR, DT_AIR, DT_BLUDGEON,
             (QueryProp(P_ALIGN) < 0?DT_UNHOLY:DT_HOLY)
           })
	}));
    SetProp(P_RESISTANCE, 
        m_indices(PHYSICAL_DAMAGE_TYPES)+
        ({ DT_COLD, DT_TERROR,
           (QueryProp(P_ALIGN) < 0?DT_UNHOLY:DT_HOLY)
        }));
    SetProp(P_VULNERABILITY, 
        ({ DT_MAGIC,
           (QueryProp(P_ALIGN) < 0?DT_HOLY:DT_UNHOLY)
        }));        

    if(!is_class_member(CL_GHOST)) { AddClass(CL_GHOST); }
    call_out("add_combat_spells", 3);
}

void create_default_npc(int level)
{ create_default_Geist(level); }


int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
}
