//
// Standard Goblin
//

#include <class.h> 
#include <properties.h>
#include <combat.h>
#include <moving.h>

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)


inherit "/std/mnpc";
inherit "/std/player/moneyhandler";


string *_query_racestring()
{
    if(QueryProp(P_GENDER) == MALE)
    {
	return ({"Goblin", "Goblins", "Goblin", "Goblin"});
    }
    else
    {
	return ({"Goblinfrau", "Goblinfraus", "Goblinfrau", "Goblinfrau"});
    }
}


void create_default_goblin(int level)
{
    int	num;

    ::create_default_npc(level);
    SetProp(P_SPELLRATE, 5+level/2+random(level*2)); 
    if(QueryProp(P_SPELLRATE) >= 100)
    { SetProp(P_SPELLRATE, 80+random(16)); }

    if(level <= 35+random(6))
    { 
	SetProp(P_ATTRIBUTES, 
	    ([A_CON: level+(random(level)/6)-(random(level)/6)-1,
	      A_DEX: level+(random(level)/6)-(random(level)/6)+9,
	      A_INT: level+(random(level)/6)-(random(level)/6)-1,
	      A_STR: level+(random(level)/6)-(random(level)/6)-1
	    ]));
    }
    else
    {
	SetProp(P_ATTRIBUTES, ([A_CON: 35, A_DEX: 35, A_INT: 35, A_STR: 35]));
    }
    
    SetProp(P_BODY, (level<30?level*2:level)+random(15));
    SetProp(P_HANDS, 
	({" mit starken Faeusten",
	  30+(level/3)*10+random(10),
	  DT_BLUDGEON
	}));
    AddId("\ngoblin");
    AddId("goblin");
    
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "Goblin");
    SetProp(P_RACE, "Goblins");
    SetProp(P_SHORT, "Ein Goblin ohne alles");
    SetProp(P_LONG, "Ein Goblin ohne Besonderheiten.\n");
    SetProp(P_AVERAGE_SIZE, 120);
    SetProp(P_SIZE, random(41)+100);
    SetProp(P_AVERAGE_WEIGHT, 40000);
    SetProp(P_WEIGHT, random(40000)+10000);
    SetProp(P_ATTRIBUTES_OFFSETS, 
	([A_DEX: 4, A_CON:0, A_INT: -1, A_STR: 2]));
    SetProp(P_MAX_HANDS, 2);
    SetProp(P_AGGRESSIVE, 0);
    SetProp(P_RESISTANCE, 0);
    SetProp(P_VULNERABILITY, 0);
    SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN: 5, T_RANGE_MAX: 35]));  
    SetProp(P_NOMAGIC, 0);
    SetProp(P_DIE_MSG, " faellt mit einem Schrei zu Boden.\n" );
    AddInfo(DEFAULT_INFO,"mustert Dich veraechtlich.\n");
    SetProp(P_MSGIN,"huscht herein");
    SetProp(P_MSGOUT,"huscht#");
    SetProp(P_MMSGIN,"verfestigt sich");
    SetProp(P_MMSGOUT,"loest sich vor Deinen Augen auf");    
    SetProp(P_MAX_FOOD, 160);
    SetProp(P_MAX_ALCOHOL, 80);
    SetProp(P_MAX_DRINK, 100);
    
    SetProp(P_ALIGN, -500+random(500)+random(500));
    

    AddClass(CL_HUMANOID);
    AddClass(CL_GOBLIN);        
}

void create_default_npc(int level)
{ 
create_default_goblin(level); 
}

int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
}
