/* Tamedhon MUDLIB
 * Samtpfote@Tamedhon.at
 *
 * das Kerbholz fuer die spieler
 *
 * v1.0.0       - 26.9.2001 Samtpfote vorerst endgueltige finalversion
 *  1.0.1       - 26.9.2001 Typos und so ausgebessert
 */
#include <properties.h>
#include <wizlevels.h>
#include <combat.h>
#include "./kerbholz.h"

#define KHMAT   "khmaterial"
#define KHSTR   "khstring"

#define VERSION "1.0.1"
#define DB(x)   "/room/debug"->debug_message(this_object(), x)

inherit "std/weapon";

int     alte_stufe;

string  zahltostr(int zahl)
{
    string      ret;
    
    ret=to_string(zahl);
    if(zahl < 10)
    {
        ret=({"null","ein","zwei","drei","vier","fuenf","sechs",
              "sieben","acht", "neun"})[zahl];
    }
    
    return ret;
}

mapping MATMAP(int stufe)
{
    mapping     map;
    
    map=([KHMAT: MAT_STRAW, KHSTR: "buggenden Stroh"]); 

    switch(stufe)
    {
        case 1: map= ([KHMAT: MAT_BIRCH_WOOD, KHSTR: "Birkenholz"]); break;
        case 2: map= ([KHMAT: MAT_BEECH, KHSTR: "Buchenholz"]); break;
        case 3: map= ([KHMAT: MAT_ASH_WOOD, KHSTR: "Eschenholz"]); break;
        case 4: map= ([KHMAT: MAT_YEW_WOOD, KHSTR: "Eibenholz"]); break;
        case 5: map= ([KHMAT: MAT_OAK, KHSTR: "Eichenholz"]); break;
        case 6: map= ([KHMAT: MAT_IVORY, KHSTR: "gedrechselten Elfenbein"]); break;
        case 7: map= ([KHMAT: MAT_CRYSTAL, KHSTR: "reinen Kristall"]); break;
        case 8: map= ([KHMAT: MAT_QUARTZ, KHSTR: "puren Quartz"]); break;
        case 9: map= ([KHMAT: MAT_AMBER, KHSTR: "schoenen Bernstein"]); break;
        case 10: map= ([KHMAT: MAT_OBSIDIAN, KHSTR: "schwarzen Obsidian"]); break;
        case 11: map= ([KHMAT: MAT_EMERALD, KHSTR: "puren Smaragd"]); break;
        case 12: map= ([KHMAT: MAT_SAPPHIRE, KHSTR: "glaenzenden Saphir"]); break;
        case 13: map= ([KHMAT: MAT_RUBY, KHSTR: "blutroten Rubin"]);
        case 14: map= ([KHMAT: MAT_DIAMOND, KHSTR: "puren Diamant"]); break;
        case 15: map= ([KHMAT: MAT_SILVER, KHSTR: "getriebenen Silber"]); break;
        case 16: map= ([KHMAT: MAT_GOLD, KHSTR: "puren Gold"]); break;
        case 17: map= ([KHMAT: MAT_PLATINUM, KHSTR: "schoenen Platin"]); break;
        case 18: map= ([KHMAT: ([MAT_MITHRIL:95, MAT_DIAMOND: 5]), KHSTR: "diamantbesetzten Mithril"]); break;
        case 19: map= ([KHMAT: ([MAT_ADAMANT:95, MAT_RUBY: 5]), KHSTR: "rubinbesetzten Adamant"]); break;
    }
    
    return map;
}

mapping query_kerben()
{
    object      env;

    env=environment();
    // DB(sprintf("env=%O", env));
    
    if(!env) return ([]);
    if(!interactive(env)) return ([]);
    
    return KHMASTER->query_kills(env);
}

int count_kerben()
{
    int         *kc, sum, i, is;
    
    sum = 0;
    kc = m_values(query_kerben());
    is = sizeof(kc);
    if(is)
    {
        for(i = 0; i<is; i++) { sum+=kc[i]; }
    }
    return sum;
}

void update_kerbholz()
{
    int stufe;
    object owner;

    owner=environment();
    if(!owner || !interactive(environment()))
    { call_out("remove", 0); return; }

    switch(count_kerben())
    {
        case 0..50:             stufe=1; break;
        case 51..100:           stufe=2; break;
        case 101..300:          stufe=3; break;
        case 301..600:          stufe=4; break;
        case 601..1000:         stufe=5; break;
        case 1001..1500:        stufe=6; break;
        case 1501..2000:        stufe=7; break;
        case 2001..2600:        stufe=8; break;
        case 2601..3200:        stufe=9; break;
        case 3201..3800:        stufe=10; break;
        case 3801..4400:        stufe=11; break;
        case 4401..5000:        stufe=12; break;
        case 5501..6000:        stufe=13; break;
        case 6001..6500:        stufe=14; break;
        case 6501..7000:        stufe=15; break;
        case 7001..7500:        stufe=16; break;
        case 7501..8000:        stufe=17; break;
        case 8001..8500:        stufe=18; break;
        default:                stufe=19; break;
    }

    SetProp(P_MATERIAL, MATMAP(stufe)[KHMAT]);
    SetProp(P_NAME, "Kerbholz aus "+MATMAP(stufe)[KHSTR]);
    SetProp(P_SHORT, "Ein Kerbholz aus "+MATMAP(stufe)[KHSTR]);
    SetProp(P_LONG, break_string(
        "Das ist Dein persoenliches Kerbholz aus "+MATMAP(stufe)[KHSTR]+". "+
        "Es vibriert leicht, als waere es lebendig."));
    SetProp(P_WC, 50+stufe);
    if(alte_stufe != stufe)
    {
        tell_object(owner, break_string(
            "Ploetzlich huellt sich Dein Kerbholz in eine magische Wolke "+
            "und verwandelt sich in ein Kerbholz "+
            "aus "+MATMAP(stufe)[KHSTR]+"!"));
    }    
    alte_stufe=stufe;
}

int kerben_zaehlen(string str)
{
    if(str == "kerben")
    {
        update_kerbholz();
        write(break_string(sprintf(
            "Du zaehlst die Anzahl der Kerben auf Deinem Kerbholz und "+
            "stellst fest, dass Du bis jetzt %s Gegner getoetet hast. "+
            "Es teilt Dir ausserdem mit, dass es %s verschiedene "+
            "waren.",
            zahltostr(count_kerben()), 
            
            zahltostr(sizeof(m_indices(query_kerben()))) )));
        return 1;
    }
}

int kerben_indikator(string str)
{
    string      was, wen;
    object      owner, opfer;
    int         numkills;

    notify_fail("Was moechtest Du auf wen richten?\n");
    if(!str||(str == "")) return 0;
    if(sscanf(str, "%s auf %s", was, wen) != 2) return 0;    
    owner=environment();
    if(!interactive(owner)) return 0;
    
    opfer=present(wen, environment(owner));    
    if(!opfer)
    {
        notify_fail("Dieser NPC ist gerade nicht hier.\n");
        return 0;
    }
    if(owner->QueryProp(P_SP) < 5) 
    {
        notify_fail("Deine magische Energie reicht nicht aus, "
                    "um das Kerbholz damit aufzuladen.\n");
        return 0;
    }    
    if(id(was) && (opfer->QueryProp(P_NPC)))
    {
        owner->SetProp(P_SP, owner->QueryProp(P_SP)-5);
        numkills=query_kerben()[efun::explode(file_name(opfer), "#")[0]];
        
        tell_object(owner, break_string(
            sprintf("Du richtest Dein Kerbholz auf %s, das kurz "+
                    "geheimnisvoll vibriert. Es teilt Dir mit, dass Du "+
                    "%s %s erlegt hast.",
                    opfer->name(WEN), opfer->QueryPronoun(WEN),
                    (numkills?" schon "+zahltostr(numkills)+"mal":"noch nie")
                    )
            ));
        tell_room(environment(owner), break_string(
            sprintf("%s richtet ein Kerbholz auf %s, das kurz geheimnisvoll "+
                    "zu vibrieren scheint.",
                    owner->Name(), opfer->name(WEN))),
            ({ owner }));
        return 1;
    }
    
    return 0;
}

int kerben_status(string str)
{
    object      owner;
    
    owner=environment();
    if(!owner) return 0;
    if(!interactive(owner)) return 0;
    if(!IS_ARCH(owner)) return 0;
    
    if(IS_ARCH(owner))
    {
        KHMASTER->query_kerb_status(owner);
        return 1;
    }
    
    return 0;
}

int _query_autoloadobj()
{
    return ((count_kerben() > 1000) || 
            IS_LEARNER(environment()) ||
            (environment() && environment()->QueryProp(P_TESTPLAYER))
           );
}

void reset()
{
    ::reset();
    KHMASTER->reset();  // zur Sicherheit...
    
    update_kerbholz();        
}

int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
    
    AddId(KERBHOLZID);
    AddId(({"kerbholz", "kh"}));
    
    SetProp(P_GENDER, NEUTER);
    SetProp(P_NAME, "Kerbholz");
    SetProp(P_WEAPON_TYPE, WT_STAFF);
    SetProp(P_DAM_TYPE, ({DT_PIERCE, DT_BLUDGEON}));
    SetProp(P_WC, 50);
    SetProp(P_NODROP, "Das Kerbholz bleibt an Deinen Haenden kleben!\n");
    SetProp(P_WEIGHT, 500);
    SetProp(P_VALUE, 24000);
    SetProp(P_NOBUY, 1);
    SetProp(P_INFO, "Eine Hilfe zu den Befehlen kannst Du mit "+
                    "'hilfe kerbholz' abrufen. Dieses Kerbholz "+
                    "hat die Revision "+VERSION+".\n");

    AddCmd(({"zaehl", "zaehle"}), "kerben_zaehlen");
    AddCmd(({"richt", "richte"}), "kerben_indikator");
    AddCmd(({"kerbholzstatus", "khstatus"}), "kerben_status");
        
    alte_stufe=1;    
    call_out("update_kerbholz", 1);
}
