/* SilberLand MUDlib
 *
 * /secure/combat.c -- combat master object
 *
 * $Date: 1997/05/12 13:23:02 $
 * $Revision: 1.2 $
 * $Log: combat.c,v $
 * Revision 1.2  1997/05/12 13:23:02  Feyaria
 * waffenuebrprruefung mit define aus sys/comabt.h
 *
 * Revision 1.1  1997/03/15 22:42:58  Woody
 * prepared for revision control
 *
 */

/*
 * the combat master object. It defines some useful functions to be
 * used by weapons, armour and livings.
 */

#include <combat.h>

default_weapon_class(type) {
	switch(type) {
		case "knife":
			return 50;
		case "club":
			return 70;
		case "sword":
			return 100;
		case "axe":
			return 90;
	}
	return 30;
}

default_weapon_weight(type) {
	switch(type) {
		case "knife":
			return 100;
		case "club":
			return 1500;
		case "sword":
			return 2000;
		case "axe":
			return 1500;
	}
	return 1000;
}

default_weapon_value(type) {
	switch(type) {
		case "knife":
			return 10;
		case "club":
			return 50;
		case "sword":
			return 500;
		case "axe":
			return 300;
	}
}

valid_weapon_type(t) {
	if ( VALID_WEAPON_TYPE(t) ) {
		 return t;
	}
	else {
		log_file("COMBAT","Invalid weapon type: "+t+", object: "+
				file_name(previous_object())+"\n");
		return 0;
	}
}


valid_armour_type(t) {
	if (VALID_ARMOUR_TYPE(t)) {
		 return t;
	}
	else {
		log_file("COMBAT","Invalid armour type: "+t+", object: "+
				file_name(previous_object())+"\n");
		return 0;
	}
}


query_prevent_shadow() { return 1; }
