// SilberLand MUDlib
//
// sys/thing/description.h -- standard thing description header
//
// $Date: 1997/03/31 15:51:00 $
/* $Revision: 2.3 $
 * $Log: description.h,v $
 * Revision 2.3  1997/03/31 15:51:00  Woody
 * Prototyp fuer Name()
 *
 * Revision 2.2  1997/03/31 15:48:09  Woody
 * prepared for revision control
 *
 * Revision 2.1  1996/05/25  15:00:00  Woody
 * P_SOUND und P_SMELL eingefuehrt
 *
 * Revision 2.0  1996/04/17  02:15:00  Woody
 * details hier reingepflanzt
 *
 * Revision 1.41 1996/01/23  20:00:00  Hadra
 * P_NO_INVIS eingefuehrt
 *
 * Revision 1.4  1995/08/07  19:09:16  Wargon
 * Prototypes fuer RemoveId/Adjective
 *
 * Revision 1.3  1994/11/03  00:31:51  Jof
 * *** empty log message ***
 *
 * Revision 1.2  1994/09/29  15:40:27  Jof
 * *** empty log message ***
 *
 * Revision 1.1  1994/09/23  20:30:43  Hate
 * Initial revision
 *
 */
 
#ifndef __THING_DESCRIPTION_H__
#define __THING_DESCRIPTION_H__

// properties
#define P_NAME       "name"       // name of the object
#define P_ORIG_NAME  "orig_name"  // original name of the object (corpse)
#define P_NAME_ADJ   "name_adj"   // adjective of the name of the object
#define P_SHORT      "short"      // short desciption of the object
#define P_LONG       "long"       // long description of the object
#define P_IDS        "ids"        // identifier of the object
#define P_ADJECTIVES "adjectives" // adjectives of the object
#define P_SHOW_INV   "show_inv"   // Show in inventory of player
#define P_NO_INVIS   "no_invis"   // can't be made invisible
#define P_CLASS      "class"      // class, like "undead" or "explosive"

#define P_DETAILS         "details"
#define P_SPECIAL_DETAILS "special_details"
#define P_READ_DETAILS    "read_details"

#define P_SOUND "sound"
#define P_SMELL "smell"

#endif // __THING_DESCRIPTION_H__

#ifdef NEED_PROTOTYPES

#ifndef __THING_DESCRIPTION_H_PROTO__
#define __THING_DESCRIPTION_H_PROTO__

// prototypes

// detail handling
void AddDetail(mixed *keys, mixed descr);
void RemoveDetail(mixed *keys);
void AddSpecialDetail(mixed keys, string function);
void RemoveSpecialDetail(mixed keys);
void AddReadDetail(mixed keys, string descr);
void RemoveReadDetail(mixed keys);

// sound/smell handling
varargs string GetSmell(mixed race);
varargs string GetSound(mixed race);

// check if the objects can by identified by str
varargs int id(string str, int lvl);

// add an id to the current object
void AddId(mixed str);

// remove an id from the object
void RemoveId(mixed str);

// add an adjective to describe the object
void AddAdjective(mixed str);

// remove an adjective from the object
void RemoveAdjective(mixed str);

// get the name with casus and demonstrative
varargs string name(int casus, int demon);

// capitalize(name())
varargs string Name(int casus, int demon);

#endif // __THING_DESCRIPTION_H_PROTO__

#endif	// NEED_PROTOYPES
